︠97ab2091-7f81-4168-8e7d-345f6031f444︠
# sage eh Python -- podemos definir uma funcao, por exemplo:
def hello(n):
    print 'Hello world!\n' * n
hello(2)
︡500e07af-7612-4e48-be1f-b377feed1220︡{"stdout": "Hello world!\nHello world!"}︡
︠242f2413-3b52-4371-8585-b3b886cb21b2︠
# (eh *quase* Python, na verdade...)
print 2**3, 2^3, eval("2^3")
︡23ea227b-29d9-4b2e-85c0-d909eb0dd1f4︡{"stdout": "8 8 1"}︡
︠d246e247-a88e-4b06-ab31-c4301aabf196︠
# vem com varios modulos prontos para serem importados
import numpy
import scipy
import pylab

x = numpy.linspace(0, 10*3.14, 1000)
y = numpy.sin(x)
pylab.close()
pylab.plot(x, y)
pylab.show()
pylab.savefig('sin.png')
︡953733f6-1842-47e4-9864-52d752a3a387︡︡
︠26be9c1f-8b8c-4449-9427-e9b1d431d543︠
# e tem autocomplete/ajuda
#pylab.<tab>
︡5f007a5c-dfb3-457b-8623-a241505673ca︡︡
︠146cb16e-bb6d-436b-b560-852585cc5698︠
# plots 2D usando comandos nativos do Sage
f = lambda x,y: cos(x*y)
C = contour_plot(f, (-4, 4), (-4, 4))
show(C)
︡9da841ea-8406-4054-9f40-04136bfa53f1︡︡
︠0aa20f51-b4f7-45fd-8aeb-9f2cc1599781︠
def slow_logistic(n,a,lamb = 3.82):
    """
    A slow logistic map.
    """
    q = a
    for i in range(n):
        q = lamb*q*(1-q)
    return q
 
time a = slow_logistic(10^6,.5)
︡aabeb87d-3098-480d-aa6d-9b4e0e811e43︡{"stdout": "Time: CPU 4.91 s, Wall: 4.93 s"}︡
︠51a80202-abeb-419e-ad3a-386f1e104f4e︠
%cython 
def cython_logistic(int n, float a, float lamb = 3.82):
    cdef float q
    q = a
    for i in range(n):
        q = lamb*q*(1-q)
    return q

time a = cython_logistic(10^6,.5)
︡b084983c-d44d-457a-b19c-6e3825808c98︡{"stderr": "Traceback (most recent call last):        cdef float q\n  File \"/home/server2/sage/local/lib/python2.5/site-packages/sage/server/support.py\", line 362, in cython_import_all\n    create_local_c_file=create_local_c_file)\n  File \"/home/server2/sage/local/lib/python2.5/site-packages/sage/server/support.py\", line 343, in cython_import\n    create_local_c_file=create_local_c_file)\n  File \"/home/server2/sage/local/lib/python2.5/site-packages/sage/misc/cython.py\", line 344, in cython\n    raise RuntimeError, \"Error converting %s to C:\\n%s\\n%s\"%(filename, log, err)\nRuntimeError: Error converting /home/server2/sage_notebook/worksheets/roberto/0/code/sage39.spyx to C:\n\n\nError converting Pyrex file to C:\n------------------------------------------------------------\n...\n    q = a\n    for i in range(n):\n        q = lamb*q*(1-q)\n    return q\n\ntime a = cython_logistic(10^6,.5)    ^\n------------------------------------------------------------\n\n/home/sage13/.sage/temp/sage/22788/spyx/_home_server2_sage_notebook_worksheets_roberto_0_code_sage39_spyx/_home_server2_sage_notebook_worksheets_roberto_0_code_sage39_spyx_0.pyx:13:5: Syntax error in simple statement list"}︡
︠d758ee8d-86cf-47c6-959f-f6712b003333︠
# resolvendo equacoes diferenciais via Maxima
t = var('t')    # define a variable t
x = function('x',t)   # define x to be a function of that variable
DE = lambda y: diff(y,t) + y - 1
resposta = desolve(DE(x(t)), [x,t])
print resposta
︡8e006243-eff5-4de1-a847-2db7e46e2e4d︡{"stdout": "%e^-t*(%e^t+%c)"}︡
︠46172e49-1218-420d-b597-04e231d7be66︠
# plots parametricos interativos
u, v = var('u,v')
fx = u*v
fy = u
fz = v^2
P = parametric_plot3d([fx, fy, fz], (u, -1, 1), (v, -1, 1), frame=False, color="yellow")
show(P)
︡019f9cfa-39ac-48bb-90fe-6c29f9318649︡︡
︠ef622f67-11af-4f31-bed2-ed0e75639545︠
@interact
def rwalk3d(n=(50,1000), frame=True):
    pnt = [0,0,0]
    v = [copy(pnt)]
    for i in range(int(n)):
        pnt[0] += random()-0.5
        pnt[1] += random()-0.5
        pnt[2] += random()-0.5
        v.append(copy(pnt))
    show(line3d(v,color='black'),aspect_ratio=[1,1,1],frame=frame)
︡2380252e-b6bb-4321-8fc0-8424bb56cf89︡{"html": "<!--notruncate--><div padding=6 id='div-interact-11'> <table width=800px height=20px bgcolor='#c5c5c5'\n                 cellpadding=15><tr><td bgcolor='#f9f9f9' valign=top align=left><table><tr><td align=right><font color=\"black\">n&nbsp;</font></td><td><table><tr><td>\n    \t<div id='slider-n-11' class='ui-slider-3' style='padding:0px;margin:0px;'><span class='ui-slider-handle'></span></div>\n    \t</td><td><font color='black' id='slider-n-11-lbl'></font></td></tr></table><script>(function(){ var values = [\"50.0\",\"51.9038076152\",\"53.8076152305\",\"55.7114228457\",\"57.6152304609\",\"59.5190380762\",\"61.4228456914\",\"63.3266533066\",\"65.2304609218\",\"67.1342685371\",\"69.0380761523\",\"70.9418837675\",\"72.8456913828\",\"74.749498998\",\"76.6533066132\",\"78.5571142285\",\"80.4609218437\",\"82.3647294589\",\"84.2685370741\",\"86.1723446894\",\"88.0761523046\",\"89.9799599198\",\"91.8837675351\",\"93.7875751503\",\"95.6913827655\",\"97.5951903808\",\"99.498997996\",\"101.402805611\",\"103.306613226\",\"105.210420842\",\"107.114228457\",\"109.018036072\",\"110.921843687\",\"112.825651303\",\"114.729458918\",\"116.633266533\",\"118.537074148\",\"120.440881764\",\"122.344689379\",\"124.248496994\",\"126.152304609\",\"128.056112224\",\"129.95991984\",\"131.863727455\",\"133.76753507\",\"135.671342685\",\"137.575150301\",\"139.478957916\",\"141.382765531\",\"143.286573146\",\"145.190380762\",\"147.094188377\",\"148.997995992\",\"150.901803607\",\"152.805611222\",\"154.709418838\",\"156.613226453\",\"158.517034068\",\"160.420841683\",\"162.324649299\",\"164.228456914\",\"166.132264529\",\"168.036072144\",\"169.93987976\",\"171.843687375\",\"173.74749499\",\"175.651302605\",\"177.55511022\",\"179.458917836\",\"181.362725451\",\"183.266533066\",\"185.170340681\",\"187.074148297\",\"188.977955912\",\"190.881763527\",\"192.785571142\",\"194.689378758\",\"196.593186373\",\"198.496993988\",\"200.400801603\",\"202.304609218\",\"204.208416834\",\"206.112224449\",\"208.016032064\",\"209.919839679\",\"211.823647295\",\"213.72745491\",\"215.631262525\",\"217.53507014\",\"219.438877756\",\"221.342685371\",\"223.246492986\",\"225.150300601\",\"227.054108216\",\"228.957915832\",\"230.861723447\",\"232.765531062\",\"234.669338677\",\"236.573146293\",\"238.476953908\",\"240.380761523\",\"242.284569138\",\"244.188376754\",\"246.092184369\",\"247.995991984\",\"249.899799599\",\"251.803607214\",\"253.70741483\",\"255.611222445\",\"257.51503006\",\"259.418837675\",\"261.322645291\",\"263.226452906\",\"265.130260521\",\"267.034068136\",\"268.937875752\",\"270.841683367\",\"272.745490982\",\"274.649298597\",\"276.553106212\",\"278.456913828\",\"280.360721443\",\"282.264529058\",\"284.168336673\",\"286.072144289\",\"287.975951904\",\"289.879759519\",\"291.783567134\",\"293.687374749\",\"295.591182365\",\"297.49498998\",\"299.398797595\",\"301.30260521\",\"303.206412826\",\"305.110220441\",\"307.014028056\",\"308.917835671\",\"310.821643287\",\"312.725450902\",\"314.629258517\",\"316.533066132\",\"318.436873747\",\"320.340681363\",\"322.244488978\",\"324.148296593\",\"326.052104208\",\"327.955911824\",\"329.859719439\",\"331.763527054\",\"333.667334669\",\"335.571142285\",\"337.4749499\",\"339.378757515\",\"341.28256513\",\"343.186372745\",\"345.090180361\",\"346.993987976\",\"348.897795591\",\"350.801603206\",\"352.705410822\",\"354.609218437\",\"356.513026052\",\"358.416833667\",\"360.320641283\",\"362.224448898\",\"364.128256513\",\"366.032064128\",\"367.935871743\",\"369.839679359\",\"371.743486974\",\"373.647294589\",\"375.551102204\",\"377.45490982\",\"379.358717435\",\"381.26252505\",\"383.166332665\",\"385.070140281\",\"386.973947896\",\"388.877755511\",\"390.781563126\",\"392.685370741\",\"394.589178357\",\"396.492985972\",\"398.396793587\",\"400.300601202\",\"402.204408818\",\"404.108216433\",\"406.012024048\",\"407.915831663\",\"409.819639279\",\"411.723446894\",\"413.627254509\",\"415.531062124\",\"417.434869739\",\"419.338677355\",\"421.24248497\",\"423.146292585\",\"425.0501002\",\"426.953907816\",\"428.857715431\",\"430.761523046\",\"432.665330661\",\"434.569138277\",\"436.472945892\",\"438.376753507\",\"440.280561122\",\"442.184368737\",\"444.088176353\",\"445.991983968\",\"447.895791583\",\"449.799599198\",\"451.703406814\",\"453.607214429\",\"455.511022044\",\"457.414829659\",\"459.318637275\",\"461.22244489\",\"463.126252505\",\"465.03006012\",\"466.933867735\",\"468.837675351\",\"470.741482966\",\"472.645290581\",\"474.549098196\",\"476.452905812\",\"478.356713427\",\"480.260521042\",\"482.164328657\",\"484.068136273\",\"485.971943888\",\"487.875751503\",\"489.779559118\",\"491.683366733\",\"493.587174349\",\"495.490981964\",\"497.394789579\",\"499.298597194\",\"501.20240481\",\"503.106212425\",\"505.01002004\",\"506.913827655\",\"508.817635271\",\"510.721442886\",\"512.625250501\",\"514.529058116\",\"516.432865731\",\"518.336673347\",\"520.240480962\",\"522.144288577\",\"524.048096192\",\"525.951903808\",\"527.855711423\",\"529.759519038\",\"531.663326653\",\"533.567134269\",\"535.470941884\",\"537.374749499\",\"539.278557114\",\"541.182364729\",\"543.086172345\",\"544.98997996\",\"546.893787575\",\"548.79759519\",\"550.701402806\",\"552.605210421\",\"554.509018036\",\"556.412825651\",\"558.316633267\",\"560.220440882\",\"562.124248497\",\"564.028056112\",\"565.931863727\",\"567.835671343\",\"569.739478958\",\"571.643286573\",\"573.547094188\",\"575.450901804\",\"577.354709419\",\"579.258517034\",\"581.162324649\",\"583.066132265\",\"584.96993988\",\"586.873747495\",\"588.77755511\",\"590.681362725\",\"592.585170341\",\"594.488977956\",\"596.392785571\",\"598.296593186\",\"600.200400802\",\"602.104208417\",\"604.008016032\",\"605.911823647\",\"607.815631263\",\"609.719438878\",\"611.623246493\",\"613.527054108\",\"615.430861723\",\"617.334669339\",\"619.238476954\",\"621.142284569\",\"623.046092184\",\"624.9498998\",\"626.853707415\",\"628.75751503\",\"630.661322645\",\"632.565130261\",\"634.468937876\",\"636.372745491\",\"638.276553106\",\"640.180360721\",\"642.084168337\",\"643.987975952\",\"645.891783567\",\"647.795591182\",\"649.699398798\",\"651.603206413\",\"653.507014028\",\"655.410821643\",\"657.314629259\",\"659.218436874\",\"661.122244489\",\"663.026052104\",\"664.929859719\",\"666.833667335\",\"668.73747495\",\"670.641282565\",\"672.54509018\",\"674.448897796\",\"676.352705411\",\"678.256513026\",\"680.160320641\",\"682.064128257\",\"683.967935872\",\"685.871743487\",\"687.775551102\",\"689.679358717\",\"691.583166333\",\"693.486973948\",\"695.390781563\",\"697.294589178\",\"699.198396794\",\"701.102204409\",\"703.006012024\",\"704.909819639\",\"706.813627255\",\"708.71743487\",\"710.621242485\",\"712.5250501\",\"714.428857715\",\"716.332665331\",\"718.236472946\",\"720.140280561\",\"722.044088176\",\"723.947895792\",\"725.851703407\",\"727.755511022\",\"729.659318637\",\"731.563126253\",\"733.466933868\",\"735.370741483\",\"737.274549098\",\"739.178356713\",\"741.082164329\",\"742.985971944\",\"744.889779559\",\"746.793587174\",\"748.69739479\",\"750.601202405\",\"752.50501002\",\"754.408817635\",\"756.312625251\",\"758.216432866\",\"760.120240481\",\"762.024048096\",\"763.927855711\",\"765.831663327\",\"767.735470942\",\"769.639278557\",\"771.543086172\",\"773.446893788\",\"775.350701403\",\"777.254509018\",\"779.158316633\",\"781.062124248\",\"782.965931864\",\"784.869739479\",\"786.773547094\",\"788.677354709\",\"790.581162325\",\"792.48496994\",\"794.388777555\",\"796.29258517\",\"798.196392786\",\"800.100200401\",\"802.004008016\",\"803.907815631\",\"805.811623246\",\"807.715430862\",\"809.619238477\",\"811.523046092\",\"813.426853707\",\"815.330661323\",\"817.234468938\",\"819.138276553\",\"821.042084168\",\"822.945891784\",\"824.849699399\",\"826.753507014\",\"828.657314629\",\"830.561122244\",\"832.46492986\",\"834.368737475\",\"836.27254509\",\"838.176352705\",\"840.080160321\",\"841.983967936\",\"843.887775551\",\"845.791583166\",\"847.695390782\",\"849.599198397\",\"851.503006012\",\"853.406813627\",\"855.310621242\",\"857.214428858\",\"859.118236473\",\"861.022044088\",\"862.925851703\",\"864.829659319\",\"866.733466934\",\"868.637274549\",\"870.541082164\",\"872.44488978\",\"874.348697395\",\"876.25250501\",\"878.156312625\",\"880.06012024\",\"881.963927856\",\"883.867735471\",\"885.771543086\",\"887.675350701\",\"889.579158317\",\"891.482965932\",\"893.386773547\",\"895.290581162\",\"897.194388778\",\"899.098196393\",\"901.002004008\",\"902.905811623\",\"904.809619238\",\"906.713426854\",\"908.617234469\",\"910.521042084\",\"912.424849699\",\"914.328657315\",\"916.23246493\",\"918.136272545\",\"920.04008016\",\"921.943887776\",\"923.847695391\",\"925.751503006\",\"927.655310621\",\"929.559118236\",\"931.462925852\",\"933.366733467\",\"935.270541082\",\"937.174348697\",\"939.078156313\",\"940.981963928\",\"942.885771543\",\"944.789579158\",\"946.693386774\",\"948.597194389\",\"950.501002004\",\"952.404809619\",\"954.308617234\",\"956.21242485\",\"958.116232465\",\"960.02004008\",\"961.923847695\",\"963.827655311\",\"965.731462926\",\"967.635270541\",\"969.539078156\",\"971.442885772\",\"973.346693387\",\"975.250501002\",\"977.154308617\",\"979.058116232\",\"980.961923848\",\"982.865731463\",\"984.769539078\",\"986.673346693\",\"988.577154309\",\"990.480961924\",\"992.384769539\",\"994.288577154\",\"996.19238477\",\"998.096192385\",\"1000.0\"]; setTimeout(function() {\n    $('#slider-n-11').slider({\n    \tstepping: 1, minValue: 0, maxValue: 499, startValue: 0,\n    \tchange: function () { var position = Math.ceil($('#slider-n-11').slider('value')); if(values!=null) $('#slider-n-11-lbl').text(values[position]); interact(11, \"sage.server.notebook.interact.update(11, \\\"n\\\", 1, sage.server.notebook.interact.standard_b64decode(\\\"\"+encode64(position)+\"\\\"), globals())\"); },\n    \tslide: function() { if(values!=null) $('#slider-n-11-lbl').text(values[Math.ceil($('#slider-n-11').slider('value'))]); }\n    });\n    if(values != null) $('#slider-n-11-lbl').text(values[Math.ceil($('#slider-n-11').slider('value'))]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">frame&nbsp;</font></td><td><input type='checkbox' checked width=200px onchange='interact(11, \"sage.server.notebook.interact.update(11, \\\"frame\\\", 2, sage.server.notebook.interact.standard_b64decode(\\\"\"+encode64(this.checked)+\"\\\"), globals())\")'></input></td></tr>\n</table><div id='cell-interact-11'><?__SAGE__START>\n        <table border=0 bgcolor='#white' width=100% height=100%>\n        <tr><td bgcolor=white align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡{"stdout": "CPU time: 0.01 s,  Wall time: 0.01 s"}︡
︠e3532c08-a35f-4f8b-be56-45621f1673fe︠
var('x')
x0  = 0
f   = sin(x)*e^(-x)
p   = plot(f,-1,5, thickness=2)
dot = point((x0,f(x0)),pointsize=80,rgbcolor=(1,0,0))
@interact
def _(order=(1..12)):
  ft = f.taylor(x,x0,order)
  pt = plot(ft,-1, 5, color='green', thickness=2)
  html('$f(x)\;=\;%s$'%latex(f))
  html('$\hat{f}(x;%s)\;=\;%s+\mathcal{O}(x^{%s})$'%(x0,latex(ft),order+1))
  show(dot + p + pt, ymin = -.5, ymax = 1)
︡4ad64ec7-32eb-4896-8623-c9e1912aed47︡{"html": "<!--notruncate--><div padding=6 id='div-interact-0'> <table width=800px height=20px bgcolor='#c5c5c5'\n                 cellpadding=15><tr><td bgcolor='#f9f9f9' valign=top align=left><table><tr><td align=right><font color=\"black\">order&nbsp;</font></td><td><table><tr><td>\n    \t<div id='slider-order-0' class='ui-slider-3' style='padding:0px;margin:0px;'><span class='ui-slider-handle'></span></div>\n    \t</td><td><font color='black' id='slider-order-0-lbl'></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\"]; setTimeout(function() {\n    $('#slider-order-0').slider({\n    \tstepping: 1, minValue: 0, maxValue: 11, startValue: 0,\n    \tchange: function () { var position = Math.ceil($('#slider-order-0').slider('value')); if(values!=null) $('#slider-order-0-lbl').text(values[position]); interact(0, \"sage.server.notebook.interact.update(0, \\\"order\\\", 3, sage.server.notebook.interact.standard_b64decode(\\\"\"+encode64(position)+\"\\\"), globals())\"); },\n    \tslide: function() { if(values!=null) $('#slider-order-0-lbl').text(values[Math.ceil($('#slider-order-0').slider('value'))]); }\n    });\n    if(values != null) $('#slider-order-0-lbl').text(values[Math.ceil($('#slider-order-0').slider('value'))]);\n    }, 1); })();</script></td></tr>\n</table><div id='cell-interact-0'><?__SAGE__START>\n        <table border=0 bgcolor='#white' width=100% height=100%>\n        <tr><td bgcolor=white align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡{"stdout": "CPU time: 0.12 s,  Wall time: 0.34 s"}︡
